# PatchTask

Extends \Task

Patches a file by applying a 'diff' file to it

Requires "patch" to be on the execution path.

package | phing.tasks.ext

### Methods

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Flag to create backups

    setBackups(boolean $backups) : void

Optional, default - false

### Arguments

#### $backups

`boolean`

If true create backups

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## The name of a file to send the output to, instead of patching the file(s) in place

    setDestFile(string $file) : void

Optional.

### Arguments

#### $file

`string`

File to send the output to

## The directory to run the patch command in

    setDir(string $directory) : void

Defaults to the project's base directory.

### Arguments

#### $directory

`string`

Directory to run the patch command in

## Ignore patches that seem to be reversed or already applied

    setForward(boolean $flag) : void

### Arguments

#### $flag

`boolean`

If true set the -N (--forward) option

## Set the maximum fuzz factor

    setFuzz(string $value) : void

Defaults to 0

### Arguments

#### $value

`string`

Value of a fuzz factor

## If true, stop the build process if the patch command exits with an error status.

    setHaltOnFailure(boolean $value) : void

The default is "false"

### Arguments

#### $value

`boolean`

"true" if it should halt, otherwise "false"

## Flag to ignore whitespace differences;

    setIgnoreWhiteSpace(boolean $ignore) : void

Default - false

### Arguments

#### $ignore

`boolean`

If true ignore whitespace differences

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## The file to patch

    setOriginalFile(string $file) : void

Optional if it can be inferred from the diff file.

### Arguments

#### $file

`string`

File to patch

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## The file containing the diff output

    setPatchFile(string $file) : void

Required.

throws | if $file not exists

### Arguments

#### $file

`string`

File containing the diff output

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Work silently unless an error occurs

    setQuiet(boolean $flag) : void

Optional, default - false

### Arguments

#### $flag

`boolean`

If true suppress set the -s option on the patch command

## Assume patch was created with old and new files swapped

    setReverse(boolean $flag) : void

Optional, default - false

### Arguments

#### $flag

`boolean`

If true set the -R option on the patch command

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Strip the smallest prefix containing <i>num</i> leading slashes from filenames.

    setStrip(integer $num) : void

patch's --strip option.

throws | if num is < 0, or other errors

### Arguments

#### $num

`integer`

number of lines to strip

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

### Constants

## Base command to be executed (must end with a space character!)

    CMD

var |

### Properties

## File to be patched

    originalFile : string

var |

### Type(s)

`string`

## Patch file

    patchFile : string

var |

### Type(s)

`string`

## Value for a "-p" option

    strip : integer

var |

### Type(s)

`integer`

## Command line arguments for patch binary

    cmdArgs : array

var |

### Type(s)

`array`

## Halt on error return value from patch invocation.

    haltOnFailure : boolean

var |

### Type(s)

`boolean`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`